<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>LanguageCodegen xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/languages/common/extensionpoints/LanguageCodegen.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*******************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2015 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *     CEA LIST - ansgar.radermacher@cea.fr   initial API and implementation</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> *******************************************************************************/</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.languages.common.extensionpoints;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> java.util.HashMap;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> java.util.List;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.Map;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Matcher;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> java.util.regex.Pattern;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.CoreException;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IConfigurationElement;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.IExtensionRegistry;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.core.runtime.Platform;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.IDialogConstants;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.jface.dialogs.MessageDialog;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Display;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Classifier;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment"> * Common interface to generate code. Supports for multiple target languages via</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment"> * the Eclipse extension mechanism</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/LanguageCodegen.html">LanguageCodegen</a> {
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String CLASS = <span class="jxr_string">"class"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String LANGUAGE = <span class="jxr_string">"language"</span>;<em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String ID = <span class="jxr_string">"id"</span>;<em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String ILANG_SUPPORT_ID = Activator.PLUGIN_ID + <span class="jxr_string">".languageCodegen"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * Interactively choose a generator for a given set of languages (pattern).</em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 * If only one generator is available, it returns this generator</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 * immediately.</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 * @param languagePattern</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * @param classifier</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> chooseGenerator(Pattern languagePattern, Classifier classifier) {
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  		List&lt;ILangCodegen&gt; eligibleGenerators = getEligibleGeneratorList(languagePattern, classifier);
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  		<strong class="jxr_keyword">if</strong> (eligibleGenerators.size() == 1) {
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  			<strong class="jxr_keyword">return</strong> eligibleGenerators.get(0);
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		}
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		Shell shell = Display.getDefault().getActiveShell();
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		<strong class="jxr_keyword">if</strong> (eligibleGenerators.size() &gt; 1) {
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  			GeneratorSelectionDialog dialog = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/GeneratorSelectionDialog.html">GeneratorSelectionDialog</a>(shell, eligibleGenerators);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  			<strong class="jxr_keyword">if</strong> (dialog.open() == IDialogConstants.OK_ID) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  				<strong class="jxr_keyword">return</strong> (ILangCodegen) dialog.getResult()[0];
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			}
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  		}
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			<em class="jxr_comment">// echo language pattern in a more readible way: without escape characters that are used for</em>
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  			<em class="jxr_comment">// the "+" in C++</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  			String pattern = languagePattern.pattern().replace(<span class="jxr_string">"&#92;&#92;"</span>, <span class="jxr_string">""</span>); <em class="jxr_comment">//$NON-NLS-1$ //$NON-NLS-2$</em>
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			MessageDialog.openError(shell, Messages.LanguageCodegen_NoGeneratorsFound,
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  					String.format(Messages.LanguageCodegen_NoGeneratorsFoundLong, pattern));			
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  		}
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  			
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  	}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  <em class="jxr_javadoccomment">	 * Get a code generator via language and ID.</em>
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  <em class="jxr_javadoccomment">	 * @param languagePattern</em>
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  <em class="jxr_javadoccomment">	 *            a pattern containing a list of supported languages</em>
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  <em class="jxr_javadoccomment">	 * @return a code generator</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> getGenerator(String language) {
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  		<em class="jxr_comment">// compile language into a pattern, escape "+"</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  		<strong class="jxr_keyword">return</strong> getGenerator(Pattern.compile(language.replace(<span class="jxr_string">"+"</span>, <span class="jxr_string">"&#92;&#92;+"</span>)), <strong class="jxr_keyword">null</strong>);  <em class="jxr_comment">//$NON-NLS-1$//$NON-NLS-2$</em>
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  	}
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  	
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  <em class="jxr_javadoccomment">	 * Get a code generator via language and ID.</em>
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  <em class="jxr_javadoccomment">	 * @param languagePattern</em>
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  <em class="jxr_javadoccomment">	 *            a pattern containing a list of supported languages</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_javadoccomment">	 * @return a code generator</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> getGenerator(String language, String id) {
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<strong class="jxr_keyword">return</strong> getGenerator(Pattern.compile(language), id);
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	}
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 * Get a code generator via language and ID.</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 * @param languagePattern</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 *            a pattern containing a list of supported languages</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 * @param id</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> <em class="jxr_javadoccomment">	 *            a string determining the id of the code generator. If null,</em>
<a class="jxr_linenumber" name="L108" href="#L108">108</a> <em class="jxr_javadoccomment">	 *            the first available generator is returned.</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 * @return a code generator</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> getGenerator(Pattern languagePattern, String id) {
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		List&lt;ILangCodegen&gt; generators = getCodegenList(languagePattern);
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		<strong class="jxr_keyword">for</strong> (ILangCodegen generator : generators) {
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 			<strong class="jxr_keyword">if</strong> ((id == <strong class="jxr_keyword">null</strong>) || generatorIDs.get(generator).equals(id)) {
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 				<strong class="jxr_keyword">return</strong> generator;
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 			}
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		}
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.LanguageSupport_LanguageNotSupported, languagePattern));
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 	}
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L122" href="#L122">122</a> <em class="jxr_javadoccomment">	 * Get a list of generators that conform a language patterns and are</em>
<a class="jxr_linenumber" name="L123" href="#L123">123</a> <em class="jxr_javadoccomment">	 * eligible for a passe classifier</em>
<a class="jxr_linenumber" name="L124" href="#L124">124</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L125" href="#L125">125</a> <em class="jxr_javadoccomment">	 * @param languagePattern</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> <em class="jxr_javadoccomment">	 *            a language pattern</em>
<a class="jxr_linenumber" name="L127" href="#L127">127</a> <em class="jxr_javadoccomment">	 * @param classifier</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> <em class="jxr_javadoccomment">	 *            a classifier</em>
<a class="jxr_linenumber" name="L129" href="#L129">129</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L130" href="#L130">130</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;ILangCodegen&gt; getEligibleGeneratorList(Pattern languagePattern, Classifier classifier) {
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		List&lt;ILangCodegen&gt; eligibleGenerators = <strong class="jxr_keyword">new</strong> ArrayList&lt;ILangCodegen&gt;();
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<strong class="jxr_keyword">for</strong> (ILangCodegen generator : getCodegenList(languagePattern)) {
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			<strong class="jxr_keyword">if</strong> (generator instanceof ILangCodegen2) {
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 				<strong class="jxr_keyword">if</strong> (((ILangCodegen2) generator).isEligible(classifier)) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 					eligibleGenerators.add(generator);
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 				}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 			}
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 			<strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 				eligibleGenerators.add(generator);
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 			}
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 		}
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		<strong class="jxr_keyword">return</strong> eligibleGenerators;
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 * retrieve a list of code generators for a given language. The language may</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 * be a regular expression</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> <em class="jxr_javadoccomment">	 * @param language</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> List&lt;ILangCodegen&gt; getCodegenList(Pattern languagePattern) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 		IExtensionRegistry reg = Platform.getExtensionRegistry();
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 		IConfigurationElement[] configElements = reg.getConfigurationElementsFor(ILANG_SUPPORT_ID);
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 		List&lt;ILangCodegen&gt; generators = <strong class="jxr_keyword">new</strong> ArrayList&lt;ILangCodegen&gt;();
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 		<strong class="jxr_keyword">for</strong> (IConfigurationElement configElement : configElements) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 				<strong class="jxr_keyword">final</strong> String id = configElement.getAttribute(ID);
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 				<strong class="jxr_keyword">final</strong> String extLanguage = configElement.getAttribute(LANGUAGE);
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 				Matcher m = languagePattern.matcher(extLanguage);
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 				<strong class="jxr_keyword">if</strong> (m.matches()) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 					<strong class="jxr_keyword">final</strong> Object obj = configElement.createExecutableExtension(CLASS);
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 					<strong class="jxr_keyword">if</strong> (obj instanceof ILangCodegen) {
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 						ILangCodegen generator = (ILangCodegen) obj;
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 						<strong class="jxr_keyword">if</strong> (!generatorIDs.containsKey(generator)) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 							generatorIDs.put(generator, id);
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 						}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 						generators.add((ILangCodegen) obj);
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 					}
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 				}
<a class="jxr_linenumber" name="L173" href="#L173">173</a> 			} <strong class="jxr_keyword">catch</strong> (CoreException exception) {
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 				exception.printStackTrace();
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 			}
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		}
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 		<strong class="jxr_keyword">return</strong> generators;
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 	}
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 	
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 * Get a code generator for a given language</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 * @param language</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 * @deprecated This method is deprecated and kept for compatibility, since there could be more than one generator</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> <em class="jxr_javadoccomment">	 *    for a given programming language.  </em>
<a class="jxr_linenumber" name="L186" href="#L186">186</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 	@Deprecated
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> getCodegen(String language)
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 	{
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 		IExtensionRegistry reg = Platform.getExtensionRegistry();
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 		IConfigurationElement[] configElements = reg.getConfigurationElementsFor(ILANG_SUPPORT_ID);
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 		<strong class="jxr_keyword">for</strong> (IConfigurationElement configElement : configElements) {
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 			<strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 				<strong class="jxr_keyword">final</strong> String extLanguage = configElement.getAttribute(LANGUAGE);
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 				<strong class="jxr_keyword">if</strong> (extLanguage.equals(language)) {
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 					<em class="jxr_comment">// TODO: cache returned instance (avoid creating a new instance each time =&gt; more efficient, no need for static attributes)</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 					<strong class="jxr_keyword">final</strong> Object obj = configElement.createExecutableExtension(<span class="jxr_string">"class"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> 					<strong class="jxr_keyword">if</strong> (obj instanceof ILangCodegen) {
<a class="jxr_linenumber" name="L199" href="#L199">199</a> 						<strong class="jxr_keyword">return</strong> (ILangCodegen) obj;
<a class="jxr_linenumber" name="L200" href="#L200">200</a> 					}
<a class="jxr_linenumber" name="L201" href="#L201">201</a> 				}
<a class="jxr_linenumber" name="L202" href="#L202">202</a> 			} <strong class="jxr_keyword">catch</strong> (CoreException exception) {
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 				exception.printStackTrace();
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 			}
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		}
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		<strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> RuntimeException(String.format(Messages.LanguageSupport_LanguageNotSupported, language));
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 	}
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> String getID(<a href="../../../../../../../org/eclipse/papyrus/designer/languages/common/extensionpoints/ILangCodegen.html">ILangCodegen</a> generator) {
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		<strong class="jxr_keyword">return</strong> generatorIDs.get(generator);
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 	}
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 	
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 	<strong class="jxr_keyword">static</strong> Map&lt;ILangCodegen, String&gt; generatorIDs = <strong class="jxr_keyword">new</strong> HashMap&lt;ILangCodegen, String&gt;();
<a class="jxr_linenumber" name="L214" href="#L214">214</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016&#x2013;2017 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
